/*
2-oji uduotis
n17. Sudaryti dvipus sra.
Parayti paprogram, kuri terpia prie numeriu nurodyt element nauj element.
Jeigu tokio elemento nra, turi bti ivestas atitinkamas praneimas. */

#include <stdio.h>
#include <stdlib.h>
typedef struct dvipElem;
struct dvipElem {
 	             struct dvipElem *priekin;
 	             int duom;
 	             struct dvipElem *atgal;
                };
void sukurti (struct dvipElem *,struct dvipElem *);
void iterpti (struct dvipElem *, struct dvipElem *);
void spausdinti (struct dvipElem *);
void sunaikinti (struct dvipElem *, struct dvipElem *);

int main ()
{
 	struct dvipElem *pradzia, *pabaiga;
 	sukurti (&pradzia, &pabaiga);
 	iterpti (&pradzia, &pabaiga);
 	spausdinti (&pradzia);
 	sunaikinti (&pradzia, &pabaiga);
}

void sukurti (struct dvipElem *pradzia, struct dvipElem *pabaiga)
{
 	struct dvipElem *elem;
 	int x;
 	*pradzia = NULL;
 	*pabaiga = NULL;
 	printf ("Kuriamas dvipusis sraas. veskite sveikus skaiius. Nordami baigti iveskite 0\n");
 	printf ("Kuriamo srao nariai:\n");
 	scanf ("%d", &x);
 	while (x != 0)
 	 {
 	 	if (*pradzia == NULL)
 	 	  {
 	 	  	elem = (struct dvipElem) malloc (sizeof (struct dvipElem) );
 	 	  	elem->duom = x;
 	 	  	elem->priekin = NULL;
 	 	  	elem->atgal = NULL;
 	 	  	*pradzia = elem;
 	 	  	*pabaiga = elem;
 	 	  	scanf ("%d", &x);
 	 	  }
 	  else
 	     {
 	     	elem = (struct dvipElem*) malloc (sizeof (struct dvipElem) );
 	     	elem->duom = x;
 	     	(*pabaiga)->priekin = elem;
 	     	elem->atgal = *pabaiga;
 	     	elem->priekin = NULL;
 	     	*pabaiga = elem;
 	     	scanf ("%d", &x);
 	     }
 	 }
 	 printf ("Sraas skmingai sukurtas\n");
}

void spausdinti (struct dvipElem* *pradzia)
{
 	struct dvipElem *elem;
 	printf ("Spausdinamas gautasis sarasas:\n");
 	elem = *pradzia;
 	while (elem != NULL)
 	{
 	printf ("%d ", elem->duom);
 	elem = elem->priekin;
 	}
 	printf ("\n");
}


void iterpti (struct dvipElem* *pradzia, struct dvipElem* *pabaiga)
{
    struct dvipElem *elem, *elemk;
    int i, nr, x;

    printf ("veskite sveik skaii, kur norite terpti  sra:\n");
    scanf ("%d", &x);
    printf ("veskite srao elemento numer, prie kur norite terpti skaii:\n");
    scanf ("%d", &nr);

    if (nr == 1) {
    elem = (struct dvipElem*) malloc (sizeof (struct dvipElem));
    elem->duom = x;
    elem->priekin = *pradzia;
    elem->atgal = NULL;
    *pradzia = elem;
    exit;
    }

    elemk = *pradzia;


    for ( i = 1; i < nr; i++)
    {
	 elemk = elemk->priekin;
	 if (elemk == NULL)
         {
         printf ("Nepavyko terpti\n");
         exit;
         }
    }

    elem = (struct dvipElem*) malloc (sizeof (struct dvipElem));
    elem->duom = x;
    elemk->atgal->priekin = elem;
    elem->atgal = elemk->atgal;
    elem->priekin = elemk;
    elemk->atgal = elem;

    printf ("\n");
}


void sunaikinti (struct dvipElem* *pradzia, struct dvipElem* *pabaiga)
{
     struct dvipElem *elem;
     if ((*pradzia != NULL) && (*pabaiga != NULL))
        {
        printf("Naikiname sra\n");
        while (*pradzia != NULL)
           {
           elem = *pradzia;
           *pradzia = elem->priekin;
           elem->atgal = NULL;
           printf ("naikiname %d\n", elem->duom);
           free(elem);
           }
        printf ("Sraas sunaikintas\n");
        }
     else printf ("Sraas tuias\n");
}
